#version 300 es

uniform mat4 r_projectionMatrix;
uniform mat4 r_modelViewMatrix;
uniform mat4 r_textureMatrix;
uniform vec2 gaps[4];
uniform float gap_angles[4];
uniform int gap_links[4];
uniform vec2 viewport;

layout(location = 0) in vec3 position;
out vec2 texCoord;
layout(location = 2) in vec2 texCoordRawIn;
out vec2 gap_views[4];
out mat2 gap_rotations[4];

void main()
{
    gl_Position = (r_projectionMatrix * r_modelViewMatrix) * vec4(position, 1.0);
    texCoord = (r_textureMatrix * vec4(texCoordRawIn, 0.0, 1.0)).xy;
    for (int _212 = 0; _212 < 4; )
    {
        float _137 = gap_angles[gap_links[_212]] - gap_angles[_212];
        float _185 = cos(_137);
        float _187 = sin(_137);
        vec2 _147 = ((((vec2(texCoord.x, 1.0 - texCoord.y) * viewport) - gaps[_212]) * mat2(vec2(_185, -_187), vec2(_187, _185))) + gaps[gap_links[_212]]) / viewport;
        vec2 _211 = _147;
        _211.y = 1.0 - _147.y;
        gap_views[_212] = _211;
        float _198 = cos(gap_angles[_212]);
        float _200 = sin(gap_angles[_212]);
        gap_rotations[_212] = mat2(vec2(_198, -_200), vec2(_200, _198));
        _212++;
        continue;
    }
}

