#version 300 es

uniform mat4 r_projectionMatrix;

layout(location = 3) in mat4 spriteVMTransform;
layout(location = 0) in vec2 vertPos;
out vec4 color;
layout(location = 11) in vec4 spriteRGBA;
out vec2 texCoord;
layout(location = 12) in vec4 spriteTexRegion;
layout(location = 2) in vec2 vertTexCoord;

void main()
{
    gl_Position = (r_projectionMatrix * spriteVMTransform) * vec4(vertPos, 0.0, 1.0);
    color = spriteRGBA;
    texCoord = vec2(mix(spriteTexRegion.x, spriteTexRegion.x + spriteTexRegion.z, vertTexCoord.x), 1.0 - mix(spriteTexRegion.y, spriteTexRegion.y + spriteTexRegion.w, 1.0 - vertTexCoord.y));
}

