#version 300 es
precision mediump float;
precision highp int;

uniform highp sampler2D tex;
uniform int have_alphamap;
uniform highp sampler2D alphamap;

layout(location = 0) out highp vec4 fragColor;
in highp vec2 texCoordRaw;

void main()
{
    fragColor = textureLod(tex, texCoordRaw, 0.0);
    highp vec3 _32 = fragColor.xyz * fragColor.w;
    fragColor = vec4(_32.x, _32.y, _32.z, fragColor.w);
    if (have_alphamap != 0)
    {
        fragColor.w *= textureLod(alphamap, texCoordRaw, 0.0).x;
    }
}

